zoukankan      html  css  js  c++  java
  • (并查集)Travel -- hdu -- 5441(2015 ACM/ICPC Asia Regional Changchun Online )

    http://acm.hdu.edu.cn/showproblem.php?pid=5441

    Travel

    Time Limit: 1500/1000 MS (Java/Others)    Memory Limit: 131072/131072 K (Java/Others)
    Total Submission(s): 2061    Accepted Submission(s): 711


    Problem Description
    Jack likes to travel around the world, but he doesn’t like to wait. Now, he is traveling in the Undirected Kingdom. There are n cities and m bidirectional roads connecting the cities. Jack hates waiting too long on the bus, but he can rest at every city. Jack can only stand staying on the bus for a limited time and will go berserk after that. Assuming you know the time it takes to go from one city to another and that the time Jack can stand staying on a bus is x minutes, how many pairs of city (a,b) are there that Jack can travel from city a to b without going berserk?
     
    Input
    The first line contains one integer T,T5, which represents the number of test case.

    For each test case, the first line consists of three integers n,m and q where n20000,m100000,q5000. The Undirected Kingdom has n cities and mbidirectional roads, and there are q queries.

    Each of the following m lines consists of three integers a,b and d where a,b{1,...,n} and d100000. It takes Jack d minutes to travel from city a to city band vice versa.

    Then q lines follow. Each of them is a query consisting of an integer x where x is the time limit before Jack goes berserk.

     
    Output
    You should print q lines for each test case. Each of them contains one integer as the number of pair of cities (a,b) which Jack may travel from a to b within the time limit x.

    Note that (a,b) and (b,a) are counted as different pairs and a and b must be different cities.
     
    Sample Input
    1
    5 5 3
    2 3 6334
    1 5 15724
    3 5 5705
    4 3 12382
    1 3 21726
    6000
    10000
    13000
     
    Sample Output
    2
    6
    12
     

    题意:是有n个城市,m条边包含u v w;代表u到v的时间是w;

    给q的时间x,求在x时间内Jack可以到达多少对城市;其中ab和ba是不同的;

    1
    5 5 3
    2 3 6334
    1 5 15724
    3 5 5705
    4 3 12382
    1 3 21726
    6000   ///可以到达35和53;
    10000 ///2 5 3是可以相互到达的所以有6种;
    13000 ///2 3 5 4是相通的有12种;

     
    Source
     
    #include <cstdio>
    #include <cstring>
    #include <cstdlib>
    #include <iostream>
    #include <algorithm>
    using namespace std;
    #define N 100100
    
    struct node
    {
        int u, v, w, index;
    } a[N], b[N];
    
    int r[N], f[N], Q[N];
    
    int cmp(node n1, node n2)
    {
        return n1.w < n2.w;
    }
    
    int Find(int x)
    {
        if(x!=f[x])
            f[x]=Find(f[x]);
        return f[x];
    }
    
    int main()
    {
        int t;
        scanf("%d", &t);
        while(t--)
        {
            int n, m, q, i;
            scanf("%d%d%d", &n, &m, &q);
    
            for(i=0; i<=n; i++)
            {
                f[i] = i;
                r[i] = 1;
            }
    
            for(i=0; i<m; i++)
                scanf("%d%d%d", &a[i].u, &a[i].v, &a[i].w);
            for(i=0; i<q; i++)
            {
                scanf("%d", &b[i].w);
                b[i].index = i;
            }
    
            sort(a, a+m, cmp);
            sort(b, b+q, cmp);
    
            int sum = 0, j = 0;
            for(i=0; i<q; i++)
            {
                while(j<m && a[j].w<=b[i].w)
                {
                    int fu = Find(a[j].u);
                    int fv = Find(a[j].v);
    
                    if(fu!=fv)
                    {
                        f[fu] = fv;
                        sum += r[fu]*r[fv]; ///两个集合的任意组合
                        r[fv] += r[fu];     ///r[i]代表i的根节点所包含的元素的个数
                    }
                    j++;
                }
                Q[b[i].index] = sum*2;  ///ab和ba是不一样的
            }
    
            for(i=0; i<q; i++)
                printf("%d
    ", Q[i]);
        }
        return 0;
    }
    View Code
    勿忘初心
  • 相关阅读:
    Detours的使用 HOOK类CString::LoadString函数
    04-树7 二叉搜索树的操作集 (30分)
    04-树6 Complete Binary Search Tree (30分)
    04-树5 Root of AVL Tree (25分)
    04-树4 是否同一棵二叉搜索树 (25分)
    03-树3 Tree Traversals Again (25分)
    C# 调用SQL的存储过程的接口及实现
    利用存储过程来提高数据库的更新问题
    ASP.Net MVC实现一个表单多个submit
    优化EF的性能
  • 原文地址:https://www.cnblogs.com/YY56/p/4837100.html
Copyright © 2011-2022 走看看